//+------------------------------------------------------------------+
//|                                                 UniTrendForm.mqh |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"

#include <IncGUI_v4.mqh>
#include <UniTrend/UniTrendDefines.mqh>
#include <UniTrend/UniTrendControl.mqh>

class CUniTrendForm: public CFormBase{
   public:

      CComBox            m_alert;

      CComBox            m_main;
      
      CUniTrendControl * m_cntrl;
      
      void ~CUniTrendForm(){
         delete(m_cntrl);
      }
      
      void SetType(EType type,SExtParams & par){

         if(CheckPointer(m_cntrl)==POINTER_DYNAMIC){
            m_cntrl.Hide();
            delete m_cntrl;
         }
      
         switch(type){
            case Type_ADX_PDIMDI:
               m_cntrl=new CUniTrendControl_ADX_PDIMDI();
            break;
            case Type_ADX_Level:
               m_cntrl=new CUniTrendControl_ADX_Level();      
            break;
            case Type_ADXW_PDIMDI:
               m_cntrl=new CUniTrendControl_ADXW_PDIMDI();            
            break;
            case Type_ADXW_Level:
               m_cntrl=new CUniTrendControl_ADXW_Level(); 
            break;
            case Type_Alligator:
               m_cntrl=new CUniTrendControl_Alligator();         
            break;
            case Type_AMA_Dir:
               m_cntrl=new CUniTrendControl_AMA_Dir();                
            break;
            case Type_AMA_2MA:
               m_cntrl=new CUniTrendControl_AMA_2MA();               
            break;
            case Type_ATR_Level:
               m_cntrl=new CUniTrendControl_ATR_Level();                
            break;
            case Type_BuBe_Level:
               m_cntrl=new CUniTrendControl_BuBe_Level();  
            break;
            case Type_BuBe_Dir:
               m_cntrl=new CUniTrendControl_BuBe_Dir();              
            break;
            case Type_Bands:
               m_cntrl=new CUniTrendControl_Bands();                
            break;
            case Type_CCI_Level:
               m_cntrl=new CUniTrendControl_CCI_Level();               
            break;
            case Type_Chaikin_Level:
               m_cntrl=new CUniTrendControl_Chaikin_Level();               
            break;
            case Type_DEMA_Dir:
               m_cntrl=new CUniTrendControl_DEMA_Dir();               
            break;
            case Type_DEMA_2MA:
               m_cntrl=new CUniTrendControl_DEMA_2MA();              
            break;
            case Type_DeMarker_Level:
               m_cntrl=new CUniTrendControl_DeMarker_Level();                
            break;
            case Type_Envelopes:
               m_cntrl=new CUniTrendControl_Envelopes();               
            break;
            case Type_Force_Level:
               m_cntrl=new CUniTrendControl_ForceLevel();                 
            break;
            case Type_Fractals:
               m_cntrl=new CUniTrendControl_Fractals();             
            break;
            case Type_FrAMA_Dir:
               m_cntrl=new CUniTrendControl_FrAMA_Dir();              
            break;
            case Type_FrAMA_2MA:
               m_cntrl=new CUniTrendControl_FrAMA_2MA();                
            break;
            case Type_Ichimoku_TK:
               m_cntrl=new CUniTrendControl_Ichimoku_TK();               
            break;
            case Type_Ichimoku_SASB:
               m_cntrl=new CUniTrendControl_Ichimoku_SASB();                 
            break;
            case Type_Momentum_Level:
               m_cntrl=new CUniTrendControl_Momentum_Level();               
            break;
            case Type_MFI_Level:
               m_cntrl=new CUniTrendControl_MFI_Level();             
            break;
            case Type_MA_Dir:
               m_cntrl=new CUniTrendControl_MA_Dir();               
            break;
            case Type_MA_2MA:
               m_cntrl=new CUniTrendControl_MA_2MA();               
            break;
            case Type_OsMA_Dir:
               m_cntrl=new CUniTrendControl_OsMA_Dir();            
            break;
            case Type_OsMA_Level:
               m_cntrl=new CUniTrendControl_OsMA_Level();              
            break;
            case Type_MACD_Dir:
               m_cntrl=new CUniTrendControl_MACD_Dir();              
            break;
            case Type_MACD_Level:
               m_cntrl=new CUniTrendControl_MACD_Level();              
            break;
            case Type_SAR:
               m_cntrl=new CUniTrendControl_SAR();                
            break;
            case Type_RSI_Level:
               m_cntrl=new CUniTrendControl_RSI_Level();                  
            break;
            case Type_RVI_Level:
               m_cntrl=new CUniTrendControl_RVI_Level();             
            break;
            case Type_RVI_MS:
               m_cntrl=new CUniTrendControl_RVI_MS();             
            break;
            case Type_STD_Level:
               m_cntrl=new CUniTrendControl_STD_Level(); 
            break;
            case Type_Sto_Dir:
               m_cntrl=new CUniTrendControl_Sto_Dir();             
            break;
            case Type_Sto_Level:
               m_cntrl=new CUniTrendControl_Sto_Level();              
            break;
            case Type_Sto_MS:
               m_cntrl=new CUniTrendControl_Sto_MS();              
            break;
            case Type_TEMA_Dir:
               m_cntrl=new CUniTrendControl_TEMA_Dir();                 
            break;
            case Type_TEMA_2MA:
               m_cntrl=new CUniTrendControl_TEMA_2MA();              
            break;
            case Type_TriX_Dir:
               m_cntrl=new CUniTrendControl_TriX_Dir();                
            break;
            case Type_TriX_2MA:
               m_cntrl=new CUniTrendControl_TriX_2MA();              
            break;
            case Type_VIDyA_Dir:
               m_cntrl=new CUniTrendControl_VIDyA_Dir();              
            break;
            case Type_VIDyA_2MA:
               m_cntrl=new CUniTrendControl_VIDyA_2MA();              
            break;
            case Type_Volumes:
               m_cntrl=new CUniTrendControl_Volumes();             
            break;
         } 
         
         this.SolveHeight();
         
         m_cntrl.Init(par);
      
      }

   
   private: 
      void SolveHeight(){
         if(CheckPointer(m_cntrl)==POINTER_DYNAMIC){
            m_Height=m_cntrl.ControlsCount()*20+70;
         }
      }        
      
   protected: 
         void MainProperties(){
               m_Name         =  "UniTrendForm";
               m_Width        =  FORM_WIDTH;
               m_Height       =  10;
               m_Type         =  0;                 
               m_Caption      =  "UniTrend";
               m_Movable      =  true;
               m_Resizable    =  true;
               m_CloseButton  =  true;
         }
         
         void OnInitEvent(){
            m_main.Init("m_main",COMBO_BOX_WIDTH," select type"); 
            m_alert.Init("m_alert",COMBO_BOX_WIDTH," alerts");
         }   

         void OnShowEvent(int aLeft, int aTop){
            m_alert.Show(aLeft+10,aTop+10);
            m_main.Show(aLeft+10,aTop+30);
            m_cntrl.Show(aLeft+10,aTop+50);
         }
         void OnHideEvent(){
            m_alert.Hide();
            m_main.Hide();            
            m_cntrl.Hide();
         }         
         void OnWindowChangeEvent(int aSubWindow){}
         void EventsHandler(const int id,const long& lparam,const double& dparam,const string& sparam){}
         bool OnApplyEvent(){return(true);}
         bool OnCancelEvent(){return(true);}
};
